unit uzeichenketten;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  Buttons, Menus, ComCtrls, ExtCtrls, uhilfe;

type

  { Tfzeichenketten }

  Tfzeichenketten = class(TForm)
    BitBtn1: TBitBtn;
    e5Z: TEdit;
    e10Z: TEdit;
    e_vokal: TEdit;
    etextlaenge_gesamt: TEdit;
    evokalmenge_gesamt: TEdit;
    ewortmenge_gesamt: TEdit;
    ewortmenge: TEdit;
    eVokal: TEdit;
    etextlaenge: TEdit;
    Label1: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label14: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    lbdatei: TListBox;
    MainMenu1: TMainMenu;
    Memo1: TMemo;
    menDatei: TMenuItem;
    menBearbeiten: TMenuItem;
    menHilfe: TMenuItem;
    menOeffnen: TMenuItem;
    menSpeichern: TMenuItem;
    menEnde: TMenuItem;
    menTextlaenge1Zeile: TMenuItem;
    menerste5Zeichen: TMenuItem;
    men10Zeichen: TMenuItem;
    mentextlaenge_gesamt: TMenuItem;
    menGrossbuchstaben: TMenuItem;
    menascii: TMenuItem;
    menVokaleersetzen: TMenuItem;
    menwortmenge_gesamt: TMenuItem;
    menvokalmenge_gesamt: TMenuItem;
    menWortmenge: TMenuItem;
    menVokalmenge: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    sboeffnen: TSpeedButton;
    sbSpeichern: TSpeedButton;
    sbtextlaenge: TSpeedButton;
    sbersten5Zeichen: TSpeedButton;
    sbletzten10Zeichen: TSpeedButton;
    ToolBar1: TToolBar;

    procedure men10ZeichenClick(Sender: TObject);
    procedure menasciiClick(Sender: TObject);
    procedure menEndeClick(Sender: TObject);
    procedure menerste5ZeichenClick(Sender: TObject);
    procedure menGrossbuchstabenClick(Sender: TObject);
    procedure menHilfeClick(Sender: TObject);
    procedure menOeffnenClick(Sender: TObject);
    procedure menSpeichernClick(Sender: TObject);
    procedure menTextlaenge1ZeileClick(Sender: TObject);
    procedure mentextlaenge_gesamtClick(Sender: TObject);
    procedure menVokaleersetzenClick(Sender: TObject);
    procedure menVokalmengeClick(Sender: TObject);
    procedure menvokalmenge_gesamtClick(Sender: TObject);
    procedure menWortmengeClick(Sender: TObject);
    procedure menwortmenge_gesamtClick(Sender: TObject);
    procedure sbersten5ZeichenClick(Sender: TObject);
    procedure sbletzten10ZeichenClick(Sender: TObject);
    procedure sboeffnenClick(Sender: TObject);
    procedure sbSpeichernClick(Sender: TObject);
    procedure sbtextlaengeClick(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;


var
  fzeichenketten: Tfzeichenketten;
  txt : ARRAY[1..24] OF STRING[255];
  zeilenzahl : 1..24;

implementation

{$R *.lfm}

{ Tfzeichenketten }

procedure Tfzeichenketten.menOeffnenClick(Sender: TObject);
VAR z : INTEGER;
begin
 IF opendialog1.execute THEN
   BEGIN
    lbdatei.items.loadfromfile(opendialog1.filename);
    zeilenzahl:=lbdatei.Count;                             //zählt die Textzeilen
    FOR z:=1 TO zeilenzahl DO txt[z]:=lbdatei.items[z-1];  //Textzeilen werden dem txt-Feld zugewiesen
   END;
end;

procedure Tfzeichenketten.menEndeClick(Sender: TObject);
begin
  CLOSE;
end;

procedure Tfzeichenketten.men10ZeichenClick(Sender: TObject);
begin
 e10Z.Text:=COPY(txt[1],LENGTH(txt[1])-9,10);
end;



procedure Tfzeichenketten.menasciiClick(Sender: TObject);
CONST maxZeichen = 80;
      maxZeile = 24;
VAR z,s : INTEGER;
    code : ARRAY[1..maxZeile,1..maxZeichen] OF BYTE;
    maxZeilenlaenge : INTEGER;
begin
 maxZeilenlaenge:=0;
 // ASCII-Code
 FOR z:=1 TO zeilenzahl DO
  FOR s:=1 TO LENGTH(txt[z]) DO
   BEGIN
    code[z,s]:=ORD(txt[z][s]);    // Zeichen Nr. s der Textzeile Nr. z
    IF maxZeilenlaenge < LENGTH(txt[z]) THEN maxZeilenlaenge:=LENGTH(txt[z]);
   END;

 lbdatei.Clear;

 FOR z:=1 TO zeilenzahl DO txt[z]:='';

 FOR z:=1 TO zeilenzahl DO
  FOR s:=1 TO maxZeilenlaenge DO
   txt[z]:=txt[z] + INTTOSTR(code[z,s]) + '|';

 FOR z:=1 TO zeilenzahl DO lbdatei.Items.Add(txt[z]);
end;

procedure Tfzeichenketten.menerste5ZeichenClick(Sender: TObject);
begin
 e5Z.Text:=COPY(txt[1],1,5);
end;

procedure Tfzeichenketten.menGrossbuchstabenClick(Sender: TObject);
VAR z,s : INTEGER;
begin
 // Großbuchstaben
 FOR z:=1 TO zeilenzahl DO
  FOR s:=1 TO LENGTH(txt[z]) DO
   BEGIN
    txt[z][s]:=UPCASE(txt[z][s]);    // Zeichen Nr. s der Textzeile Nr. z
   END;
 lbdatei.Clear;
 FOR z:=1 TO zeilenzahl DO lbdatei.Items.Add(txt[z]);
end;

procedure Tfzeichenketten.menHilfeClick(Sender: TObject);
begin
  fhilfe.showmodal;
end;

procedure Tfzeichenketten.menSpeichernClick(Sender: TObject);
begin
 IF savedialog1.execute THEN
    lbdatei.items.savetofile(savedialog1.filename);
end;

procedure Tfzeichenketten.menTextlaenge1ZeileClick(Sender: TObject);
begin
 etextlaenge.Text:=INTTOSTR(LENGTH(txt[1])) + ' Zeichen';
end;

procedure Tfzeichenketten.mentextlaenge_gesamtClick(Sender: TObject);
VAR z, laenge : INTEGER;
begin
 //Textlänge gesamt
 laenge:=0;
 FOR z:=1 TO zeilenzahl DO laenge := laenge + LENGTH(txt[z]);
 etextlaenge_gesamt.Text:=INTTOSTR(laenge) + ' Zeichen';
end;

procedure Tfzeichenketten.menVokaleersetzenClick(Sender: TObject);
VAR vokal : CHAR;
    z,s : INTEGER;
begin
 vokal := e_vokal.text[1];
 FOR z:=1 TO zeilenzahl DO
  FOR s:=1 TO LENGTH(txt[z]) DO
   CASE txt[z][s] OF
    'A','a' : BEGIN DELETE(txt[z],s,1); INSERT(vokal,txt[z],s) END;
    'E','e' : BEGIN DELETE(txt[z],s,1); INSERT(vokal,txt[z],s) END;
    'I','i' : BEGIN DELETE(txt[z],s,1); INSERT(vokal,txt[z],s) END;
    'O','o' : BEGIN DELETE(txt[z],s,1); INSERT(vokal,txt[z],s) END;
    'U','u' : BEGIN DELETE(txt[z],s,1); INSERT(vokal,txt[z],s) END;
   END;
 lbdatei.Clear;
 FOR z:=1 TO zeilenzahl DO lbdatei.Items.Add(txt[z]);
end;


procedure Tfzeichenketten.menVokalmengeClick(Sender: TObject);
VAR m,s : INTEGER;
begin
 m:=0;
 FOR s:=1 TO LENGTH(txt[1]) DO
  {CASE txt[1][s] OF
   'A','a' : INC(m);
   'E','e' : INC(m);
   'I','i' : INC(m);
   'O','o' : INC(m);
   'U','u' : INC(m);
  END;}
 //Variante
  CASE txt[1][s] OF
    'A','a','E','e','I','i','O','o','U','u' : INC(m);
  END;

 evokal.Text:=INTTOSTR(m)+' Vokale';
end;

procedure Tfzeichenketten.menvokalmenge_gesamtClick(Sender: TObject);
VAR m,s,z : INTEGER;
begin
 m:=0;
 FOR z:=1 TO zeilenzahl DO
  FOR s:=1 TO LENGTH(txt[z]) DO
   CASE txt[z][s] OF
    'A','a' : INC(m);
    'E','e' : INC(m);
    'I','i' : INC(m);
    'O','o' : INC(m);
    'U','u' : INC(m);
   END;
 evokalmenge_gesamt.Text:=INTTOSTR(m)+' Vokale';
end;

procedure Tfzeichenketten.menWortmengeClick(Sender: TObject);
VAR m,s : INTEGER;
begin
 m:=0;
 FOR s:=1 TO LENGTH(txt[1]) DO
  IF txt[1][s]=' ' THEN INC(m);
 ewortmenge.text:=INTTOSTR(m+1)+' Wörter';
end;

procedure Tfzeichenketten.menwortmenge_gesamtClick(Sender: TObject);
VAR m,s,z : INTEGER;
begin
 m:=0;
 FOR z:=1 TO zeilenzahl DO
  FOR s:=1 TO LENGTH(txt[z]) DO
   IF txt[z][s]=' ' THEN INC(m);
  ewortmenge_gesamt.text:=INTTOSTR(m+zeilenzahl)+' Wörter';
end;

procedure Tfzeichenketten.sbersten5ZeichenClick(Sender: TObject);
begin
 menerste5Zeichen.Click;
end;

procedure Tfzeichenketten.sbletzten10ZeichenClick(Sender: TObject);
begin
 men10Zeichen.Click;
end;

procedure Tfzeichenketten.sboeffnenClick(Sender: TObject);
begin
 menOeffnen.Click;
end;

procedure Tfzeichenketten.sbSpeichernClick(Sender: TObject);
begin
 menSpeichern.Click;
end;

procedure Tfzeichenketten.sbtextlaengeClick(Sender: TObject);
begin
 menTextlaenge1Zeile.Click;
end;

end.

